class Button #Class for buttons in menu contains position, image and lambda with action
  attr_accessor :posX, :posY, :buttonHeight, :buttonWidth, :image, :imageOver
  def initialize (x,y,img,imgOver,act,g)
    #position
    @posX = x
    @posY = y
    @image = img #image
    @actualImage = img #image to show
    @imageOver = imgOver #hover image
    @action = act #lambda with action
    @buttonWidth = @image.width.to_f #button image width
    @buttonHeight = @image.height.to_f #button image height
    @game = g #gosu game window
  end

  def isHovering #is cursor hovering over this stone
    x = @game.mouse_x
    y = @game.mouse_y
    if x >= @posX && x <= (@posX + @buttonWidth) && y >= @posY && y <= @posY + @buttonHeight
      true
    else
      false
    end
  end

  def clicked #if is cursor over button make action in lamdba
    if isHovering
      @action.call
    end
  end

  def update #set image based on if is cursor hovering over it
    if isHovering
      @actualImage = @imageOver
    else
      @actualImage = @image
    end
  end

  def draw #draw button
    @actualImage.draw(@posX, @posY, 2)
  end

end